﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Fibonacci
{
    class Program
    {
        static long[] fibArray;
        static long calculations;
        static void Main(string[] args)
        {
            int n;
            Console.Write("enter n: ");
            n = int.Parse(Console.ReadLine());
            fibArray = new long[n + 1];
            calculations = 0;
            TimeSpan t1, t2;
            t1 = DateTime.Now.TimeOfDay;
            long r = fib2(n);
            t2 = DateTime.Now.TimeOfDay;

            Console.WriteLine("\n result(Array) =  " + r + " --> calculations = " + calculations);
            Console.WriteLine("\n Time = " + (t2 - t1) + " seconds");
            calculations = 0;
            t1 = DateTime.Now.TimeOfDay;
            r = fib(n);
            t2 = DateTime.Now.TimeOfDay;
            Console.WriteLine("\n result(Recursive) =  " + r + " --> calculations = " + calculations);
            Console.WriteLine("\n Time = " + (t2 - t1) + " seconds");
        }
        public static long fib(int n) {
            calculations++;
            if (n <= 1) 
                return n; 
            else
                return fib(n - 1) + fib(n - 2);

        }
        public static long fib2(int n)
        {
            fibArray[0] = 0;
            fibArray[1] = 1;
            calculations+=2;
            for (int i = 2; i <= n; i++)
            {
                fibArray[i] = fibArray[i - 1] + fibArray[i - 2];
                calculations++;
            }
            return fibArray[n];
        }
    }
}
