﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Management;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public static string GetOSFriendlyName() {
            string result = string.Empty;
            ManagementObjectSearcher searcher = new ManagementObjectSearcher("SELECT Caption FROM Win32_OperatingSystem");
            foreach (ManagementObject os in searcher.Get()) {
                result = os["Caption"].ToString(); 
                break; 
            } return 
            result; 
        } 
        static ulong GetTotalMemoryInMB() {
            return (new Microsoft.VisualBasic.Devices.ComputerInfo().TotalPhysicalMemory) / (1024 * 1024);
        }
        public string Get_VGA()
        {
            ManagementObjectSearcher searcher = new ManagementObjectSearcher("SELECT * FROM Win32_DisplayConfiguration");
            string graphicsCard = string.Empty; foreach (ManagementObject mo in searcher.Get())
            {
                foreach (PropertyData property in mo.Properties)
                {
                    if (property.Name == "Description") {
                        graphicsCard = property.Value.ToString();
                    }
                }
            } return graphicsCard;
        }
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            var cpu = new ManagementObjectSearcher("select * from Win32_Processor").Get().Cast<ManagementObject>().First();
            richTextBox1.Text = (string)cpu["Name"] + " " + Environment.ProcessorCount.ToString() + " Cores"; 
            //============== 
            richTextBox1.Text += " , " + Environment.SystemDirectory + " , " + GetOSFriendlyName() + " , " + "RAM Size :" + GetTotalMemoryInMB() + " MB"; 
            richTextBox1.Text += " , VGA = " + Get_VGA();
            
        }
    }
}
